--	Invisibility script

--	(made by Alistaire)


settings = {}

		--[[	SETTINGS
		--
		--				* change settings to whatever you want
		--				* any indented settings /need/ the setting above to be true
		--]]


settings.markerSet = false						-- set a marker above invisible players (boolean)
	settings.markerImage = 'gfx/flare1.bmp<a>'			-- what image should the marker be ('path')
	settings.markerRGB = {'255', '255', '255'}			-- what color should the marker have ({'RRR', 'GGG', 'BBB'})
	settings.markerAlpha = '0.5'						-- what opacity should the marker have (0.0 -> 1.0)

settings.stutteryCamo = false					-- make the camo "stuttery" (boolean)
	settings.stutteryCamoRange = {'95', '100'}			-- what opacity range should it stutter between ({'minimal * 100', 'maximal * 100'})

		--[[ 	DECLARATIONS
		--
		--				* better not change stuff here, actually
		--]]

function array(value)
	local a = {}
	for i = 1, 32 do
		a[i] = value
	end
	return a;
end

plr = {}
plr.invisible = array(false)
plr.images = array({0, 0, 0, 0, 0, 0, 0, 0, 0})
plr.marker = array({0, false})

		--[[ 	EXAMPLE CODE
		--
		--				* change the hooks and the like to your heart's content.
		--]]

addhook('movetile', 'movetileHook')
addhook('use', 'useHook')

function movetileHook(id, tilex, tiley)
	tryToSetImage(id, tilex, tiley)
end

function useHook(id, event, data, tilex, tiley)
	tryToSwitch(id, tilex, tiley)
end

		--[[ 	CORE CODE
		--
		--			-> call tryToSwitch(playerid, playertilex, playertiley) to switch invisibility state for a player. IT ALSO CALLS BOTH tryToSetImage AND tryToSetMarker!
		--			-> call tryToSetImage(playerid, playertilex, playertiley) to check if an image can be set for a player on and around said tile
		--			-> call tryToSetMarker(playerid) to check if a marker can be set on a player
		--
		--				* tryToSwitch calls tryToSetImage and tryToSetMarker once - tryToSetMarker should be called only once every switch, and tryToSetImage is used to generate an image on the player's switch location
		--]]

function tryToSetImage(id, tilex, tiley)
	function checkFreeImage(id, frame)
		if plr.images[id][frame] ~= 0 then
			freeimage(plr.images[id][frame])
			plr.images[id][frame] = 0
		end
	end
	for i = 1, 9 do checkFreeImage(id, i) end
	if plr.invisible[id] == true then
		for x = -1, 1 do
			local nx = tilex + x
			for y = -1, 1 do
				local ny = tiley + y
				if tile(nx, ny, 'wall') ~= true then
					local frame = 3 * (y + 1) + x + 2
					checkFreeImage(id, frame)
					plr.images[id][frame] = 1
					plr.images[id][frame] = image('<tile:'..tile(nx, ny, 'frame')..'>', nx * 32, ny * 32, 1)
					if settings.stutteryCamo == true then
						imagealpha(plr.images[id][frame], math.random(settings.stutteryCamoRange[1], settings.stutteryCamoRange[2]) * 0.01)
					end
				end
			end
		end
	end
end

function tryToSetMarker(id)
	if settings.markerSet == true then
		if plr.invisible[id] == true then
			if plr.marker[id][2] == false then
				plr.marker[id][1] = image(settings.markerImage, 0, 1, 132 + id, id)
				imagecolor(plr.marker[id][1], settings.markerRGB[1], settings.markerRGB[2], settings.markerRGB[3])
				imagealpha(plr.marker[id][1], settings.markerAlpha)
				tween_rotateconstantly(plr.marker[id][1], 2)
				plr.marker[id][2] = true
			end
		else
			if plr.marker[id][2] == true then
				freeimage(plr.marker[id][1])
				plr.marker[id][2] = false
			end
		end
	end
end

function tryToSwitch(id, tilex, tiley)
	plr.invisible[id] = (plr.invisible[id] == false) and true or false
	tryToSetImage(id, player(id, 'tilex'), player(id, 'tiley'))
	tryToSetMarker(id)
end